﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Diagram;

namespace PreventFromOverlapping
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            diagramView.NodeDragEnd += new NodeEventHandler(diagramView_NodeDragEnd);
            diagramView.NodeDrop += new NodeDroppedEventHandler(diagramView_NodeDrop);
        }

        void diagramView_NodeDrop(object sender, NodeDroppedRoutedEventArgs evtArgs)
        {
            (evtArgs.DroppedNode as Node).Loaded += new RoutedEventHandler(MainWindow_Loaded);
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            dockingTheNode((sender as Node));
        }

        void diagramView_NodeDragEnd(object sender, NodeRoutedEventArgs evtArgs)
        {
            if (evtArgs.Node.OffsetX < 0 && evtArgs.Node.OffsetY < 0)
            {
                evtArgs.Node.OffsetY = 0;
                evtArgs.Node.OffsetX = 0;
                dockingTheNode(evtArgs.Node);
            }
            else if (evtArgs.Node.OffsetX < 0)
            {
                evtArgs.Node.OffsetX = 0;
                dockingTheNode(evtArgs.Node);
            }
            else if (evtArgs.Node.OffsetY < 0)
            {
                evtArgs.Node.OffsetY = 0;
                dockingTheNode(evtArgs.Node);
            }
            else
            {
                dockingTheNode(evtArgs.Node);
            }
        }

        public void dockingTheNode(Node sourceNode)
        {
            Rect evtArgsRect = new Rect(sourceNode.OffsetX, sourceNode.OffsetY, sourceNode.Width, sourceNode.Height);

            foreach (Node n in diagramModel.Nodes)
            {
                if (n != sourceNode)
                {
                    Rect rect = new Rect(n.OffsetX, n.OffsetY, n.Width, n.Height);

                    if (rect.IntersectsWith(evtArgsRect))
                    {
                        sourceNode.OffsetX = n.OffsetX + n.Width;

                        foreach (Node n1 in diagramModel.Nodes)
                        {
                            if (n1 != sourceNode)
                            {
                                Rect evtargsRectNew = new Rect(sourceNode.OffsetX, sourceNode.OffsetY, sourceNode.Width, sourceNode.Height);

                                Rect rectNew = new Rect(n1.OffsetX, n1.OffsetY, n1.Width, n1.Height);

                                if (rectNew.IntersectsWith(evtargsRectNew))
                                {
                                    sourceNode.OffsetX = n1.OffsetX + n1.Width;
                                }
                            }
                        }
                    }
                }
            }
        }

    }
}
